Package org.lwjgl.opengl

# Class GL20

java.lang.Object
org.lwjgl.opengl.GL20

public final class GL20 extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`GL_ACTIVE_ATTRIBUTE_MAX_LENGTH`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_ACTIVE_ATTRIBUTES`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_ACTIVE_UNIFORM_MAX_LENGTH`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_ACTIVE_UNIFORMS`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_ATTACHED_SHADERS`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_BLEND_EQUATION_ALPHA`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_BLEND_EQUATION_RGB`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_BOOL`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_BOOL_VEC2`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_BOOL_VEC3`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_BOOL_VEC4`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_COMPILE_STATUS`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_COORD_REPLACE`
When the <target> parameter of TexEnvf, TexEnvfv, TexEnvi, TexEnviv, GetTexEnvfv, or GetTexEnviv is POINT_SPRITE, then the value of <pname> may be:
`static final int`
`GL_CURRENT_PROGRAM`
Accepted by the <pname> argument of GetInteger:
`static final int`
`GL_CURRENT_VERTEX_ATTRIB`
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:
`static final int`
`GL_DELETE_STATUS`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_DRAW_BUFFER0`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER1`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER10`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER11`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER12`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER13`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER14`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER15`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER2`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER3`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER4`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER5`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER6`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER7`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER8`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_DRAW_BUFFER9`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_FLOAT_MAT2`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_MAT3`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_MAT4`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_VEC2`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_VEC3`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FLOAT_VEC4`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_FRAGMENT_SHADER`
Accepted by the <shaderType> argument of CreateShader and returned by the <params> parameter of GetShader{fi}vARB:
`static final int`
`GL_FRAGMENT_SHADER_DERIVATIVE_HINT`
Accepted by the <target> parameter of Hint and the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_INFO_LOG_LENGTH`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_INT_VEC2`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_INT_VEC3`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_INT_VEC4`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_LINK_STATUS`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_LOWER_LEFT`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_DRAW_BUFFERS`
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_FRAGMENT_UNIFORM_COMPONENTS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_TEXTURE_COORDS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_TEXTURE_IMAGE_UNITS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_VARYING_FLOATS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_VERTEX_ATTRIBS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_VERTEX_UNIFORM_COMPONENTS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_POINT_SPRITE`
Accepted by the <cap> parameter of Enable, Disable, and IsEnabled, by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev, and by the <target> parameter of TexEnvi, TexEnviv, TexEnvf, TexEnvfv, GetTexEnviv, and GetTexEnvfv:
`static final int`
`GL_POINT_SPRITE_COORD_ORIGIN`
Accepted by the <pname> parameter of PointParameter{if}vARB, and the <pname> of Get:
`static final int`
`GL_SAMPLER_1D`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_1D_SHADOW`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_2D`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_2D_SHADOW`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_3D`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SAMPLER_CUBE`
Returned by the <type> parameter of GetActiveUniformARB:
`static final int`
`GL_SHADER_OBJECT`
Returned by the <params> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_SHADER_SOURCE_LENGTH`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_SHADER_TYPE`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_SHADING_LANGUAGE_VERSION`
Accepted by the <name> parameter of GetString:
`static final int`
`GL_STENCIL_BACK_FAIL`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_STENCIL_BACK_FUNC`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_STENCIL_BACK_PASS_DEPTH_FAIL`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_STENCIL_BACK_PASS_DEPTH_PASS`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_STENCIL_BACK_REF`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_STENCIL_BACK_VALUE_MASK`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_STENCIL_BACK_WRITEMASK`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_UPPER_LEFT`
Accepted by the <param> parameter of PointParameter{if}vARB:
`static final int`
`GL_VALIDATE_STATUS`
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:
`static final int`
`GL_VERTEX_ATTRIB_ARRAY_ENABLED`
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:
`static final int`
`GL_VERTEX_ATTRIB_ARRAY_NORMALIZED`
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:
`static final int`
`GL_VERTEX_ATTRIB_ARRAY_POINTER`
Accepted by the <pname> parameter of GetVertexAttribPointervARB:
`static final int`
`GL_VERTEX_ATTRIB_ARRAY_SIZE`
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:
`static final int`
`GL_VERTEX_ATTRIB_ARRAY_STRIDE`
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:
`static final int`
`GL_VERTEX_ATTRIB_ARRAY_TYPE`
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:
`static final int`
`GL_VERTEX_PROGRAM_POINT_SIZE`
Accepted by the <cap> parameter of Disable, Enable, and IsEnabled, and by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_VERTEX_PROGRAM_TWO_SIDE`
Accepted by the <cap> parameter of Disable, Enable, and IsEnabled, and by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_VERTEX_SHADER`
Accepted by the <shaderType> argument of CreateShader and returned by the <params> parameter of GetShader{if}v:

## Method Summary

Modifier and Type
Method
Description
`static void`
`glAttachShader(int program, int shader)`
`static void`
`glBindAttribLocation(int program, int index, CharSequence name)`
Overloads glBindAttribLocation.
`static void`
`glBindAttribLocation(int program, int index, ByteBuffer name)`
`static void`
`glBlendEquationSeparate(int modeRGB, int modeAlpha)`
`static void`
`glCompileShader(int shader)`
`static int`
`glCreateProgram()`
`static int`
`glCreateShader(int type)`
`static void`
`glDeleteProgram(int program)`
`static void`
`glDeleteShader(int shader)`
`static void`
`glDetachShader(int program, int shader)`
`static void`
`glDisableVertexAttribArray(int index)`
`static void`
`glDrawBuffers(int buffer)`
Overloads glDrawBuffers.
`static void`
`glDrawBuffers(IntBuffer buffers)`
`static void`
`glEnableVertexAttribArray(int index)`
`static String`
`glGetActiveAttrib(int program, int index, int maxLength)`
Overloads glGetActiveAttrib.
`static String`
`glGetActiveAttrib(int program, int index, int maxLength, IntBuffer sizeType)`
Overloads glGetActiveAttrib.
`static void`
`glGetActiveAttrib(int program, int index, IntBuffer length, IntBuffer size, IntBuffer type, ByteBuffer name)`
`static int`
`glGetActiveAttribSize(int program, int index)`
Overloads glGetActiveAttrib.
`static int`
`glGetActiveAttribType(int program, int index)`
Overloads glGetActiveAttrib.
`static String`
`glGetActiveUniform(int program, int index, int maxLength)`
Overloads glGetActiveUniform.
`static String`
`glGetActiveUniform(int program, int index, int maxLength, IntBuffer sizeType)`
Overloads glGetActiveUniform.
`static void`
`glGetActiveUniform(int program, int index, IntBuffer length, IntBuffer size, IntBuffer type, ByteBuffer name)`
`static int`
`glGetActiveUniformSize(int program, int index)`
Overloads glGetActiveUniform.
`static int`
`glGetActiveUniformType(int program, int index)`
Overloads glGetActiveUniform.
`static void`
`glGetAttachedShaders(int program, IntBuffer count, IntBuffer shaders)`
`static int`
`glGetAttribLocation(int program, CharSequence name)`
Overloads glGetAttribLocation.
`static int`
`glGetAttribLocation(int program, ByteBuffer name)`
`static int`
`glGetProgram(int program, int pname)`
Deprecated.
Will be removed in 3.0.
`static void`
`glGetProgram(int program, int pname, IntBuffer params)`
`static int`
`glGetProgrami(int program, int pname)`
Overloads glGetProgramiv.
`static String`
`glGetProgramInfoLog(int program, int maxLength)`
Overloads glGetProgramInfoLog.
`static void`
`glGetProgramInfoLog(int program, IntBuffer length, ByteBuffer infoLog)`
`static int`
`glGetShader(int shader, int pname)`
Deprecated.
Will be removed in 3.0.
`static void`
`glGetShader(int shader, int pname, IntBuffer params)`
`static int`
`glGetShaderi(int shader, int pname)`
Overloads glGetShaderiv.
`static String`
`glGetShaderInfoLog(int shader, int maxLength)`
Overloads glGetShaderInfoLog.
`static void`
`glGetShaderInfoLog(int shader, IntBuffer length, ByteBuffer infoLog)`
`static String`
`glGetShaderSource(int shader, int maxLength)`
Overloads glGetShaderSource.
`static void`
`glGetShaderSource(int shader, IntBuffer length, ByteBuffer source)`
`static void`
`glGetUniform(int program, int location, FloatBuffer params)`
`static void`
`glGetUniform(int program, int location, IntBuffer params)`
`static int`
`glGetUniformLocation(int program, CharSequence name)`
Overloads glGetUniformLocation.
`static int`
`glGetUniformLocation(int program, ByteBuffer name)`
Returns the location of the uniform with the specified name.
`static void`
`glGetVertexAttrib(int index, int pname, DoubleBuffer params)`
`static void`
`glGetVertexAttrib(int index, int pname, FloatBuffer params)`
`static void`
`glGetVertexAttrib(int index, int pname, IntBuffer params)`
`static ByteBuffer`
`glGetVertexAttribPointer(int index, int pname, long result_size)`
`static void`
`glGetVertexAttribPointer(int index, int pname, ByteBuffer pointer)`
Overloads glGetVertexAttribPointerv.
`static boolean`
`glIsProgram(int program)`
`static boolean`
`glIsShader(int shader)`
`static void`
`glLinkProgram(int program)`
`static void`
`glShaderSource(int shader, CharSequence string)`
Overloads glShaderSource.
`static void`
`glShaderSource(int shader, CharSequence[] strings)`
Overloads glShaderSource.
`static void`
`glShaderSource(int shader, ByteBuffer string)`
The ARB_shader_objects extension allows multiple, optionally null-terminated, source strings to define a shader program.
`static void`
`glStencilFuncSeparate(int face, int func, int ref, int mask)`
`static void`
`glStencilMaskSeparate(int face, int mask)`
`static void`
`glStencilOpSeparate(int face, int sfail, int dpfail, int dppass)`
`static void`
`glUniform1(int location, FloatBuffer values)`
`static void`
`glUniform1(int location, IntBuffer values)`
`static void`
`glUniform1f(int location, float v0)`
`static void`
`glUniform1i(int location, int v0)`
`static void`
`glUniform2(int location, FloatBuffer values)`
`static void`
`glUniform2(int location, IntBuffer values)`
`static void`
`glUniform2f(int location, float v0, float v1)`
`static void`
`glUniform2i(int location, int v0, int v1)`
`static void`
`glUniform3(int location, FloatBuffer values)`
`static void`
`glUniform3(int location, IntBuffer values)`
`static void`
`glUniform3f(int location, float v0, float v1, float v2)`
`static void`
`glUniform3i(int location, int v0, int v1, int v2)`
`static void`
`glUniform4(int location, FloatBuffer values)`
`static void`
`glUniform4(int location, IntBuffer values)`
`static void`
`glUniform4f(int location, float v0, float v1, float v2, float v3)`
`static void`
`glUniform4i(int location, int v0, int v1, int v2, int v3)`
`static void`
`glUniformMatrix2(int location, boolean transpose, FloatBuffer matrices)`
`static void`
`glUniformMatrix3(int location, boolean transpose, FloatBuffer matrices)`
`static void`
`glUniformMatrix4(int location, boolean transpose, FloatBuffer matrices)`
`static void`
`glUseProgram(int program)`
`static void`
`glValidateProgram(int program)`
`static void`
`glVertexAttrib1d(int index, double x)`
`static void`
`glVertexAttrib1f(int index, float x)`
`static void`
`glVertexAttrib1s(int index, short x)`
`static void`
`glVertexAttrib2d(int index, double x, double y)`
`static void`
`glVertexAttrib2f(int index, float x, float y)`
`static void`
`glVertexAttrib2s(int index, short x, short y)`
`static void`
`glVertexAttrib3d(int index, double x, double y, double z)`
`static void`
`glVertexAttrib3f(int index, float x, float y, float z)`
`static void`
`glVertexAttrib3s(int index, short x, short y, short z)`
`static void`
`glVertexAttrib4d(int index, double x, double y, double z, double w)`
`static void`
`glVertexAttrib4f(int index, float x, float y, float z, float w)`
`static void`
`glVertexAttrib4Nub(int index, byte x, byte y, byte z, byte w)`
`static void`
`glVertexAttrib4s(int index, short x, short y, short z, short w)`
`static void`
`glVertexAttribPointer(int index, int size, boolean unsigned, boolean normalized, int stride, ByteBuffer buffer)`
`static void`
`glVertexAttribPointer(int index, int size, boolean unsigned, boolean normalized, int stride, IntBuffer buffer)`
`static void`
`glVertexAttribPointer(int index, int size, boolean unsigned, boolean normalized, int stride, ShortBuffer buffer)`
`static void`
`glVertexAttribPointer(int index, int size, boolean normalized, int stride, DoubleBuffer buffer)`
`static void`
`glVertexAttribPointer(int index, int size, boolean normalized, int stride, FloatBuffer buffer)`
`static void`
`glVertexAttribPointer(int index, int size, int type, boolean normalized, int stride, long buffer_buffer_offset)`
`static void`
`glVertexAttribPointer(int index, int size, int type, boolean normalized, int stride, ByteBuffer buffer)`
Overloads glVertexAttribPointer.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### GL_SHADING_LANGUAGE_VERSION

public static final int GL_SHADING_LANGUAGE_VERSION
Accepted by the <name> parameter of GetString:

See Also:
  - Constant Field Values

### GL_CURRENT_PROGRAM

public static final int GL_CURRENT_PROGRAM
Accepted by the <pname> argument of GetInteger:

See Also:
  - Constant Field Values

### GL_SHADER_TYPE

public static final int GL_SHADER_TYPE
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_DELETE_STATUS

public static final int GL_DELETE_STATUS
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_COMPILE_STATUS

public static final int GL_COMPILE_STATUS
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_LINK_STATUS

public static final int GL_LINK_STATUS
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_VALIDATE_STATUS

public static final int GL_VALIDATE_STATUS
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_INFO_LOG_LENGTH

public static final int GL_INFO_LOG_LENGTH
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_ATTACHED_SHADERS

public static final int GL_ATTACHED_SHADERS
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_ACTIVE_UNIFORMS

public static final int GL_ACTIVE_UNIFORMS
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_ACTIVE_UNIFORM_MAX_LENGTH

public static final int GL_ACTIVE_UNIFORM_MAX_LENGTH
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_ACTIVE_ATTRIBUTES

public static final int GL_ACTIVE_ATTRIBUTES
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_ACTIVE_ATTRIBUTE_MAX_LENGTH

public static final int GL_ACTIVE_ATTRIBUTE_MAX_LENGTH
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_SHADER_SOURCE_LENGTH

public static final int GL_SHADER_SOURCE_LENGTH
Accepted by the <pname> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_SHADER_OBJECT

public static final int GL_SHADER_OBJECT
Returned by the <params> parameter of GetObjectParameter{fi}vARB:

See Also:
  - Constant Field Values

### GL_FLOAT_VEC2

public static final int GL_FLOAT_VEC2
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_VEC3

public static final int GL_FLOAT_VEC3
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_VEC4

public static final int GL_FLOAT_VEC4
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_INT_VEC2

public static final int GL_INT_VEC2
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_INT_VEC3

public static final int GL_INT_VEC3
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_INT_VEC4

public static final int GL_INT_VEC4
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL

public static final int GL_BOOL
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_VEC2

public static final int GL_BOOL_VEC2
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_VEC3

public static final int GL_BOOL_VEC3
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_BOOL_VEC4

public static final int GL_BOOL_VEC4
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_MAT2

public static final int GL_FLOAT_MAT2
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_MAT3

public static final int GL_FLOAT_MAT3
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_FLOAT_MAT4

public static final int GL_FLOAT_MAT4
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_1D

public static final int GL_SAMPLER_1D
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D

public static final int GL_SAMPLER_2D
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_3D

public static final int GL_SAMPLER_3D
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_CUBE

public static final int GL_SAMPLER_CUBE
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_1D_SHADOW

public static final int GL_SAMPLER_1D_SHADOW
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_SHADOW

public static final int GL_SAMPLER_2D_SHADOW
Returned by the <type> parameter of GetActiveUniformARB:

See Also:
  - Constant Field Values

### GL_VERTEX_SHADER

public static final int GL_VERTEX_SHADER
Accepted by the <shaderType> argument of CreateShader and returned by the <params> parameter of GetShader{if}v:

See Also:
  - Constant Field Values

### GL_MAX_VERTEX_UNIFORM_COMPONENTS

public static final int GL_MAX_VERTEX_UNIFORM_COMPONENTS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_VARYING_FLOATS

public static final int GL_MAX_VARYING_FLOATS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_VERTEX_ATTRIBS

public static final int GL_MAX_VERTEX_ATTRIBS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_TEXTURE_IMAGE_UNITS

public static final int GL_MAX_TEXTURE_IMAGE_UNITS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS

public static final int GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS

public static final int GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_TEXTURE_COORDS

public static final int GL_MAX_TEXTURE_COORDS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_VERTEX_PROGRAM_POINT_SIZE

public static final int GL_VERTEX_PROGRAM_POINT_SIZE
Accepted by the <cap> parameter of Disable, Enable, and IsEnabled, and by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_VERTEX_PROGRAM_TWO_SIDE

public static final int GL_VERTEX_PROGRAM_TWO_SIDE
Accepted by the <cap> parameter of Disable, Enable, and IsEnabled, and by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_VERTEX_ATTRIB_ARRAY_ENABLED

public static final int GL_VERTEX_ATTRIB_ARRAY_ENABLED
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:

See Also:
  - Constant Field Values

### GL_VERTEX_ATTRIB_ARRAY_SIZE

public static final int GL_VERTEX_ATTRIB_ARRAY_SIZE
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:

See Also:
  - Constant Field Values

### GL_VERTEX_ATTRIB_ARRAY_STRIDE

public static final int GL_VERTEX_ATTRIB_ARRAY_STRIDE
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:

See Also:
  - Constant Field Values

### GL_VERTEX_ATTRIB_ARRAY_TYPE

public static final int GL_VERTEX_ATTRIB_ARRAY_TYPE
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:

See Also:
  - Constant Field Values

### GL_VERTEX_ATTRIB_ARRAY_NORMALIZED

public static final int GL_VERTEX_ATTRIB_ARRAY_NORMALIZED
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:

See Also:
  - Constant Field Values

### GL_CURRENT_VERTEX_ATTRIB

public static final int GL_CURRENT_VERTEX_ATTRIB
Accepted by the <pname> parameter of GetVertexAttrib{dfi}vARB:

See Also:
  - Constant Field Values

### GL_VERTEX_ATTRIB_ARRAY_POINTER

public static final int GL_VERTEX_ATTRIB_ARRAY_POINTER
Accepted by the <pname> parameter of GetVertexAttribPointervARB:

See Also:
  - Constant Field Values

### GL_FRAGMENT_SHADER

public static final int GL_FRAGMENT_SHADER
Accepted by the <shaderType> argument of CreateShader and returned by the <params> parameter of GetShader{fi}vARB:

See Also:
  - Constant Field Values

### GL_MAX_FRAGMENT_UNIFORM_COMPONENTS

public static final int GL_MAX_FRAGMENT_UNIFORM_COMPONENTS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_FRAGMENT_SHADER_DERIVATIVE_HINT

public static final int GL_FRAGMENT_SHADER_DERIVATIVE_HINT
Accepted by the <target> parameter of Hint and the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_DRAW_BUFFERS

public static final int GL_MAX_DRAW_BUFFERS
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER0

public static final int GL_DRAW_BUFFER0
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER1

public static final int GL_DRAW_BUFFER1
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER2

public static final int GL_DRAW_BUFFER2
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER3

public static final int GL_DRAW_BUFFER3
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER4

public static final int GL_DRAW_BUFFER4
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER5

public static final int GL_DRAW_BUFFER5
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER6

public static final int GL_DRAW_BUFFER6
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER7

public static final int GL_DRAW_BUFFER7
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER8

public static final int GL_DRAW_BUFFER8
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER9

public static final int GL_DRAW_BUFFER9
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER10

public static final int GL_DRAW_BUFFER10
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER11

public static final int GL_DRAW_BUFFER11
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER12

public static final int GL_DRAW_BUFFER12
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER13

public static final int GL_DRAW_BUFFER13
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER14

public static final int GL_DRAW_BUFFER14
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_DRAW_BUFFER15

public static final int GL_DRAW_BUFFER15
Accepted by the <pname> parameters of GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_POINT_SPRITE

public static final int GL_POINT_SPRITE
Accepted by the <cap> parameter of Enable, Disable, and IsEnabled, by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev, and by the <target> parameter of TexEnvi, TexEnviv, TexEnvf, TexEnvfv, GetTexEnviv, and GetTexEnvfv:

See Also:
  - Constant Field Values

### GL_COORD_REPLACE

public static final int GL_COORD_REPLACE
When the <target> parameter of TexEnvf, TexEnvfv, TexEnvi, TexEnviv, GetTexEnvfv, or GetTexEnviv is POINT_SPRITE, then the value of <pname> may be:

See Also:
  - Constant Field Values

### GL_POINT_SPRITE_COORD_ORIGIN

public static final int GL_POINT_SPRITE_COORD_ORIGIN
Accepted by the <pname> parameter of PointParameter{if}vARB, and the <pname> of Get:

See Also:
  - Constant Field Values

### GL_LOWER_LEFT

public static final int GL_LOWER_LEFT
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_UPPER_LEFT

public static final int GL_UPPER_LEFT
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_FUNC

public static final int GL_STENCIL_BACK_FUNC
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_FAIL

public static final int GL_STENCIL_BACK_FAIL
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_PASS_DEPTH_FAIL

public static final int GL_STENCIL_BACK_PASS_DEPTH_FAIL
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_PASS_DEPTH_PASS

public static final int GL_STENCIL_BACK_PASS_DEPTH_PASS
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_REF

public static final int GL_STENCIL_BACK_REF
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_VALUE_MASK

public static final int GL_STENCIL_BACK_VALUE_MASK
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_STENCIL_BACK_WRITEMASK

public static final int GL_STENCIL_BACK_WRITEMASK
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_BLEND_EQUATION_RGB

public static final int GL_BLEND_EQUATION_RGB
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

### GL_BLEND_EQUATION_ALPHA

public static final int GL_BLEND_EQUATION_ALPHA
Accepted by the <param> parameter of PointParameter{if}vARB:

See Also:
  - Constant Field Values

## Method Details

### glShaderSource

public static void glShaderSource(int shader, ByteBuffer string)
The ARB_shader_objects extension allows multiple, optionally null-terminated, source strings to define a shader program.

This method uses just a single string, that should NOT be null-terminated.

Parameters:
  `shader` -
  `string` -

### glShaderSource

public static void glShaderSource(int shader, CharSequence string)
Overloads glShaderSource.

### glShaderSource

public static void glShaderSource(int shader, CharSequence[] strings)
Overloads glShaderSource.

### glCreateShader

public static int glCreateShader(int type)

### glIsShader

public static boolean glIsShader(int shader)

### glCompileShader

public static void glCompileShader(int shader)

### glDeleteShader

public static void glDeleteShader(int shader)

### glCreateProgram

public static int glCreateProgram()

### glIsProgram

public static boolean glIsProgram(int program)

### glAttachShader

public static void glAttachShader(int program, int shader)

### glDetachShader

public static void glDetachShader(int program, int shader)

### glLinkProgram

public static void glLinkProgram(int program)

### glUseProgram

public static void glUseProgram(int program)

### glValidateProgram

public static void glValidateProgram(int program)

### glDeleteProgram

public static void glDeleteProgram(int program)

### glUniform1f

public static void glUniform1f(int location, float v0)

### glUniform2f

public static void glUniform2f(int location, float v0, float v1)

### glUniform3f

public static void glUniform3f(int location, float v0, float v1, float v2)

### glUniform4f

public static void glUniform4f(int location, float v0, float v1, float v2, float v3)

### glUniform1i

public static void glUniform1i(int location, int v0)

### glUniform2i

public static void glUniform2i(int location, int v0, int v1)

### glUniform3i

public static void glUniform3i(int location, int v0, int v1, int v2)

### glUniform4i

public static void glUniform4i(int location, int v0, int v1, int v2, int v3)

### glUniform1

public static void glUniform1(int location, FloatBuffer values)

### glUniform2

public static void glUniform2(int location, FloatBuffer values)

### glUniform3

public static void glUniform3(int location, FloatBuffer values)

### glUniform4

public static void glUniform4(int location, FloatBuffer values)

### glUniform1

public static void glUniform1(int location, IntBuffer values)

### glUniform2

public static void glUniform2(int location, IntBuffer values)

### glUniform3

public static void glUniform3(int location, IntBuffer values)

### glUniform4

public static void glUniform4(int location, IntBuffer values)

### glUniformMatrix2

public static void glUniformMatrix2(int location, boolean transpose, FloatBuffer matrices)

### glUniformMatrix3

public static void glUniformMatrix3(int location, boolean transpose, FloatBuffer matrices)

### glUniformMatrix4

public static void glUniformMatrix4(int location, boolean transpose, FloatBuffer matrices)

### glGetShader

public static void glGetShader(int shader, int pname, IntBuffer params)

### glGetShader

@Deprecated public static int glGetShader(int shader, int pname)
Deprecated.
Will be removed in 3.0. Use `glGetShaderi(int, int)` instead.
Overloads glGetShaderiv.

### glGetShaderi

public static int glGetShaderi(int shader, int pname)
Overloads glGetShaderiv.

### glGetProgram

public static void glGetProgram(int program, int pname, IntBuffer params)

### glGetProgram

@Deprecated public static int glGetProgram(int program, int pname)
Deprecated.
Will be removed in 3.0. Use `glGetProgrami(int, int)` instead.
Overloads glGetProgramiv.

### glGetProgrami

public static int glGetProgrami(int program, int pname)
Overloads glGetProgramiv.

### glGetShaderInfoLog

public static void glGetShaderInfoLog(int shader, IntBuffer length, ByteBuffer infoLog)

### glGetShaderInfoLog

public static String glGetShaderInfoLog(int shader, int maxLength)
Overloads glGetShaderInfoLog.

### glGetProgramInfoLog

public static void glGetProgramInfoLog(int program, IntBuffer length, ByteBuffer infoLog)

### glGetProgramInfoLog

public static String glGetProgramInfoLog(int program, int maxLength)
Overloads glGetProgramInfoLog.

### glGetAttachedShaders

public static void glGetAttachedShaders(int program, IntBuffer count, IntBuffer shaders)

### glGetUniformLocation

public static int glGetUniformLocation(int program, ByteBuffer name)
Returns the location of the uniform with the specified name. The ByteBuffer should contain the uniform name as a null-terminated string.

Parameters:
  `program` -
  `name` -

### glGetUniformLocation

public static int glGetUniformLocation(int program, CharSequence name)
Overloads glGetUniformLocation.

### glGetActiveUniform

public static void glGetActiveUniform(int program, int index, IntBuffer length, IntBuffer size, IntBuffer type, ByteBuffer name)

### glGetActiveUniform

public static String glGetActiveUniform(int program, int index, int maxLength, IntBuffer sizeType)
Overloads glGetActiveUniform.

Overloads glGetActiveUniform. This version returns both size and type in the sizeType buffer (at .position() and .position() + 1).

### glGetActiveUniform

public static String glGetActiveUniform(int program, int index, int maxLength)
Overloads glGetActiveUniform.

Overloads glGetActiveUniformARB. This version returns only the uniform name.

### glGetActiveUniformSize

public static int glGetActiveUniformSize(int program, int index)
Overloads glGetActiveUniform.

Overloads glGetActiveUniform. This version returns only the uniform size.

### glGetActiveUniformType

public static int glGetActiveUniformType(int program, int index)
Overloads glGetActiveUniform.

Overloads glGetActiveUniform. This version returns only the uniform type.

### glGetUniform

public static void glGetUniform(int program, int location, FloatBuffer params)

### glGetUniform

public static void glGetUniform(int program, int location, IntBuffer params)

### glGetShaderSource

public static void glGetShaderSource(int shader, IntBuffer length, ByteBuffer source)

### glGetShaderSource

public static String glGetShaderSource(int shader, int maxLength)
Overloads glGetShaderSource.

### glVertexAttrib1s

public static void glVertexAttrib1s(int index, short x)

### glVertexAttrib1f

public static void glVertexAttrib1f(int index, float x)

### glVertexAttrib1d

public static void glVertexAttrib1d(int index, double x)

### glVertexAttrib2s

public static void glVertexAttrib2s(int index, short x, short y)

### glVertexAttrib2f

public static void glVertexAttrib2f(int index, float x, float y)

### glVertexAttrib2d

public static void glVertexAttrib2d(int index, double x, double y)

### glVertexAttrib3s

public static void glVertexAttrib3s(int index, short x, short y, short z)

### glVertexAttrib3f

public static void glVertexAttrib3f(int index, float x, float y, float z)

### glVertexAttrib3d

public static void glVertexAttrib3d(int index, double x, double y, double z)

### glVertexAttrib4s

public static void glVertexAttrib4s(int index, short x, short y, short z, short w)

### glVertexAttrib4f

public static void glVertexAttrib4f(int index, float x, float y, float z, float w)

### glVertexAttrib4d

public static void glVertexAttrib4d(int index, double x, double y, double z, double w)

### glVertexAttrib4Nub

public static void glVertexAttrib4Nub(int index, byte x, byte y, byte z, byte w)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, boolean normalized, int stride, DoubleBuffer buffer)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, boolean normalized, int stride, FloatBuffer buffer)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, boolean unsigned, boolean normalized, int stride, ByteBuffer buffer)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, boolean unsigned, boolean normalized, int stride, IntBuffer buffer)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, boolean unsigned, boolean normalized, int stride, ShortBuffer buffer)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, int type, boolean normalized, int stride, long buffer_buffer_offset)

### glVertexAttribPointer

public static void glVertexAttribPointer(int index, int size, int type, boolean normalized, int stride, ByteBuffer buffer)
Overloads glVertexAttribPointer.

### glEnableVertexAttribArray

public static void glEnableVertexAttribArray(int index)

### glDisableVertexAttribArray

public static void glDisableVertexAttribArray(int index)

### glGetVertexAttrib

public static void glGetVertexAttrib(int index, int pname, FloatBuffer params)

### glGetVertexAttrib

public static void glGetVertexAttrib(int index, int pname, DoubleBuffer params)

### glGetVertexAttrib

public static void glGetVertexAttrib(int index, int pname, IntBuffer params)

### glGetVertexAttribPointer

public static ByteBuffer glGetVertexAttribPointer(int index, int pname, long result_size)

### glGetVertexAttribPointer

public static void glGetVertexAttribPointer(int index, int pname, ByteBuffer pointer)
Overloads glGetVertexAttribPointerv.

### glBindAttribLocation

public static void glBindAttribLocation(int program, int index, ByteBuffer name)

### glBindAttribLocation

public static void glBindAttribLocation(int program, int index, CharSequence name)
Overloads glBindAttribLocation.

### glGetActiveAttrib

public static void glGetActiveAttrib(int program, int index, IntBuffer length, IntBuffer size, IntBuffer type, ByteBuffer name)

### glGetActiveAttrib

public static String glGetActiveAttrib(int program, int index, int maxLength, IntBuffer sizeType)
Overloads glGetActiveAttrib.

Overloads glGetActiveAttrib. This version returns both size and type in the sizeType buffer (at .position() and .position() + 1).

### glGetActiveAttrib

public static String glGetActiveAttrib(int program, int index, int maxLength)
Overloads glGetActiveAttrib.

Overloads glGetActiveAttrib. This version returns only the attrib name.

### glGetActiveAttribSize

public static int glGetActiveAttribSize(int program, int index)
Overloads glGetActiveAttrib.

Overloads glGetActiveAttribARB. This version returns only the attrib size.

### glGetActiveAttribType

public static int glGetActiveAttribType(int program, int index)
Overloads glGetActiveAttrib.

Overloads glGetActiveAttrib. This version returns only the attrib type.

### glGetAttribLocation

public static int glGetAttribLocation(int program, ByteBuffer name)

### glGetAttribLocation

public static int glGetAttribLocation(int program, CharSequence name)
Overloads glGetAttribLocation.

### glDrawBuffers

public static void glDrawBuffers(IntBuffer buffers)

### glDrawBuffers

public static void glDrawBuffers(int buffer)
Overloads glDrawBuffers.

### glStencilOpSeparate

public static void glStencilOpSeparate(int face, int sfail, int dpfail, int dppass)

### glStencilFuncSeparate

public static void glStencilFuncSeparate(int face, int func, int ref, int mask)

### glStencilMaskSeparate

public static void glStencilMaskSeparate(int face, int mask)

### glBlendEquationSeparate

public static void glBlendEquationSeparate(int modeRGB, int modeAlpha)